#!/bin/sh

if [ ! -s /tmp/version ] ; then
	echo BOOTLoader:`cat /dev/mtd/0|grep "U-Boot "|cut -f2 -d ' '`>/tmp/version
	echo CPU:`cat /proc/cpuinfo|grep CHIP_VERSION|cut -f2 -d ' '`>>/tmp/version
	echo BSP:`cat /proc/lspinfo/build_id`>>/tmp/version
	echo Kernel:`uname -r`>>/tmp/version
	echo Software:`cat /etc/version`>>/tmp/version
	echo Tool Chain:`/usr/sbin/upgrade|grep ToolChain|cut -d: -f2`>>/tmp/version
fi

FIRMWARE_STR=`grep Firmware /tmp/version`

if [ "$FIRMWARE_STR" = "" ] ; then
	FIRMWARE="`cat /proc/mei/version`"
	if [ "$FIRMWARE" != "" ] ; then
		echo Firmware:$FIRMWARE>>/tmp/version
	else
	    FIRMWARE="N/A"
	fi
else
	FIRMWARE="`echo $FIRMWARE_STR|cut -d: -f2-`"
fi

if [ $# -ge 1 ]; then
	while [ $# -ge 1 ]; do
		case $1 in
		-b) VER=BOOTLoader;;
		-c) VER=CPU;;
		-f) echo `echo $FIRMWARE|cut -d" " -f1`
			exit;;
		-k) VER=Kernel;;
		-l) VER=BSP;;
		-r) VER=Software;;
		-t) VER=Tool;;
		*) echo "'$1' Error!    Usage : version [-b|-c|-f|-k|-l|-r|-t]"
			exit
		esac
		shift
		echo `grep $VER /tmp/version|cut -d: -f2|cut -d" " -f1`
  	done
else
	cat /tmp/version
	if [ "$FIRMWARE_STR" = "" ] ; then
		echo Firmware:$FIRMWARE
	fi
fi
